package icse2011experiments;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

/**
 * Helper program to count essential and non-essential interleavings in  
 * change sets. File reads each line and checks whether there are non-essential
 * methods. if so, it checks whether these equal the total methods (i.e., 
 * no interleaving), or whether they do not (i.e., interleaving). The 
 * results are printed to the screen for each project. 
 * 
 * @author dkawry
 */
public class InterleavingCounter {

	public static void main(String[] args) {
		
		final String HOME = "/home/2005/dkawry/research/experiments/icse11/";
		final String PROJECT_FOLDER = "xerces";	// or: ant, vuze, spring, hibernate, etc. 
		
		// where EMs > NEMs && NEMs > 0 (==> interleaved) 
		try {
			Scanner scanny = new Scanner(new File(HOME + "method/" + PROJECT_FOLDER +"/methodRAW.txt"));
			
			// ignore first line (it's just header info) 
			scanny.nextLine();
			
			int c = 0;
			int m = 0;
			
			while (scanny.hasNextLine()) {
				String line = scanny.nextLine();
				if (line.endsWith("#")) {
					line = line.substring(0, line.length() - 1);
				}
				String[] tokens = line.split("#");
				if (tokens.length < 2) { 
					continue; 
				}
				String b = tokens[1];
				String aa = tokens[tokens.length - 1];
				
				Integer allMethods = Integer.parseInt(b);		// all methods
				Integer nemMethods = Integer.parseInt(aa);		// non-essential methods
				
				if (allMethods > nemMethods && nemMethods > 0) {
					c++;
					System.out.println("INTERLEAVED: " + tokens[0] + "," + allMethods + "," + nemMethods);
				}
				else if (allMethods > 0 && allMethods == nemMethods){
					m ++;
					System.out.println("NOT INTERLEAVED: " + tokens[0] + "," + allMethods + "," + nemMethods);
				}
				
			}
			
//			System.out.println(c);
//			System.out.println(m);
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
	}
	
}
