package icse2011experiments;

import java.io.File;
import java.util.Scanner;

/**
 * Helper class. Computes the proportion of method updates that were 
 * non-essential within transactions of a given size range (e.g., updating
 * between min and max methods). 
 * 
 * @author dkawry
 */
public class SizeProportionQuery {

	public static void main(String[] args) throws Exception {
		
		String[] files = new String[] {
			"/home/2005/dkawry/research/experiments/icse11/method/ant/methodRAW.txt",
			"/home/2005/dkawry/research/experiments/icse11/method/hibernate/methodRAW1.txt",
			"/home/2005/dkawry/research/experiments/icse11/method/hibernate/methodRAW2.txt",
			"/home/2005/dkawry/research/experiments/icse11/method/hibernate/methodRAW3.txt",
			"/home/2005/dkawry/research/experiments/icse11/method/hibernate/methodRAW4.txt",
			"/home/2005/dkawry/research/experiments/icse11/method/hibernate/methodRAW5.txt",
			"/home/2005/dkawry/research/experiments/icse11/method/jdt_core/methodRAW.txt",
			"/home/2005/dkawry/research/experiments/icse11/method/jdt_ui/methodRAW.txt",
			"/home/2005/dkawry/research/experiments/icse11/method/spring/methodRAW.txt",
			"/home/2005/dkawry/research/experiments/icse11/method/vuze/methodRAW.txt",
			"/home/2005/dkawry/research/experiments/icse11/method/xerces/methodRAW.txt",
		};
		
			
			final int MIN_SIZE = 21;
			final int MAX_SIZE = 1000;
			
			int numNEMs = 0;
			int numEMs = 0;
			int cs = 0;
			
			for (String file : files) 
			{
				Scanner scanner = new Scanner(new File(file));
				scanner.nextLine();
				
				while (scanner.hasNextLine()) {
					String line = scanner.nextLine();
					if (line.endsWith("#")) {
						line = line.substring(0, line.length() - 1);
					}
					
					String[] tokens = line.split("#");
					
					int size = Integer.parseInt(tokens[1]);
					
					if (size < MIN_SIZE || size >= MAX_SIZE) {
						continue;
					}
					
					numEMs += Integer.parseInt(tokens[1]);
					numNEMs += Integer.parseInt(tokens[tokens.length - 1]);
					cs ++;
				}
				
				scanner.close();
			}
			
			System.out.println( ((double) numNEMs)/numEMs + " " + numEMs + " " + cs + " [" + MIN_SIZE + "," + MAX_SIZE + ")") ;
		}
	
}
